<template>
    <div class="ml-2 mr-2">
        <b-modal @close="beforeModalCloses" :scrollable="true"  @hidden="reset" :hide-footer="true" size="xl"  ref="inputModal" id="my-modal" :title="title"  :centered="true">
        <form class="" method="POST"  @submit.prevent="onSubmit()"  @reset.prevent="reset()" @keydown=" updateFormErrors($event.target.name)" @change="updateFormErrors($event.target.name)">
            <form-wizard ref="wizard" shape="circle" color="#343a40a1" @on-loading="setLoading"  @on-change="updateStep" @on-complete="onComplete">
              <template slot="step" slot-scope="props">
                            <wizard-step :tab="props.tab"
                            :transition="props.transition"
                            :key="props.tab.title"
                            :index="props.index">
                            </wizard-step>
              </template>
              <tab-content title="Données Générales" :before-change="carStoreStep">
                        <div class="row">
                            <div class="col-md-4"> 
                                <div class="align-content-lg-center align-items-center d-flex flex-column flex-direction-column">
                                     <h4 class="bold mt-2">Logo de l'entreprise</h4>
                                    <croppa
                                        ref="cropper" 
                                        :width="250"
                                        :height="250"
                                        @image-remove="onRemoveLogo"
                                        canvas-color="transparent" 
                                        initial-size="cover"
                                        @initial-image-loaded="onInitialImageLoaded"
                                        :quality="2"
                                        :zoom-speed="7"
                                        :placeholder-font-size="16"
                                        placeholder="Chargez le logo ici"
                                        :initial-image=" entity ? ( entity.hasLogo ?'/storage/featured/'+entity.logo: null) : null"
                                        @draw="updateImage"
                                        @loading-end="updateDraw"
                                        @file-size-exceed="onFileSizeExceed"
                                        :file-size-limit="502400"
                                        @file-choose="onFileChosen"
                                        @file-type-mismatch="onFileTypeMismatch"





                                    ></croppa>
                        <div class="btns">
                            <button @click.prevent="zoomIn()"><i class="fas fa-search-plus"></i></button>
                            <button @click.prevent="zoomOut()"><i class="fas fa-search-minus"></i></button>
                                <button @click.prevent="rotateLeft()"><i class="fas fa-undo"></i></button>
                            <button @click.prevent="rotateRight()"><i class="fas fa-redo"></i></button>
                        </div>
                                </div>
                                    
                            </div>
                            <div class="col-md-8">

                        <div class="form-row">
                                <div class="form-group col-md-6">
                                    <label class="">Nom commercial <span class="star_label">*</span></label>
                                    <input placeholder="Entrez le nom de l'entreprise"  class="form-control form-control-md form-custom-input-sm" name="nom_commercial" v-model="form.nom_commercial" type="text" />

                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('nom_commercial')" v-text="form.errors.get('nom_commercial')"></span>
                                </div>
                                <div class="form-group col-md-6">
                                    <label for="inputState4">Forme juridique <span class="star_label">*</span></label>
                                    <multi-select
                                            no-ptions="Aucun type de véhicule disponible" open-direction="bottom" name="forme_juridique"
                                            v-model="form.forme_juridique"  :options="opt.fjuridiques"
                                        :show-labels="false" :searchable="true" :clear-on-select="false"
                                        :close-on-select="true"  placeholder="Choisissez la forme juridique">
                                    </multi-select>
                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('forme_juridique')" v-text="form.errors.get('forme_juridique')"></span>

                                </div>
                                <div class="form-group col-md-6">
                                    <label class="">Secteur d'activité <span class="star_label">*</span></label>
                                    <multi-select @input="trackSecteurActivite" name="secteur_activite_id"
                                    v-model="secteur_activite" :show-labels="false"
                                    open-direction="bottom" :close-on-select="true" placeholder="Choisissez le secteur d'activité"
                                    :options="_secteurs"   label="libelle" track-by="id">


                                    </multi-select>

                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('secteur_activite_id')" v-text="form.errors.get('secteur_activite_id')"></span>
                                </div>
                                <div class="form-group col-md-6 isInvalid responsable-input "> 
                                    <label class="">Responsable <span class="star_label">*</span></label>
                                    <multi-select  :showNoOptions="justTosayNo" :showNoResult="searchingMember" :loading="searchingMember" :searchable="true"  :internal-search="false" @input="trackResponsable"
                                        name="responsable_id" @search-change="asyncFind" :multiple="false"
                                    v-model="responsable" :options-limit="100" :show-labels="false"
                                    open-direction="bottom" :close-on-select="true" placeholder="Recherchez le responsable"
                                    :options="memberAsParameter"    label="fullName" track-by="id">
                                        <span slot="noResult" v-if="!searchingMember">Aucun membre trouvé</span>
                                        <span slot="noOptions">Cherchez un membre FACOP</span>
                                    </multi-select>

                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('responsable_id')" v-text="form.errors.get('responsable_id')"></span>
                                </div>

                                <div class="form-group col-md-6">
                                    <label for="inputState4">Activité Principale <span class="star_label">*</span> </label>
                                    <input placeholder="Entrez l'activité principale"  class="form-control form-control-md form-custom-input-sm" name="secteur_activite_principal" v-model="form.secteur_activite_principal" type="text" />

                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('secteur_activite_principal')" v-text="form.errors.get('secteur_activite_principal')"></span>

                                </div>
                                <div class="form-group col-md-6">
                                            <label class="">Effectif <span class="star_label">*</span></label>

                                            <multi-select
                                                @input="trackEffectif"
                                                no-ptions="Aucun revendeur disponible" open-direction="bottom"
                                                name="effectif"
                                                v-model="form.effectif" :options="['1-5','6-10','11-15','16-20','+40']"
                                                :show-labels="false" :searchable="true" :clear-on-select="false"
                                                :close-on-select="true"  placeholder="Choisissez l'effectif"
                                                >
                                            </multi-select>
                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('effectif')" v-text="form.errors.get('effectif')"></span>
                                </div>
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-12">
                                <label class="">Autre activité <span class="star_label">*</span></label>
                                <textarea placeholder="Ajoutez un détails sur vos activités"  class="form-control form-control-md form-custom-input-sm" name="autre_activite" v-model="form.autre_activite" type="text"></textarea>

                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('autre_activite')" v-text="form.errors.get('autre_activite')"></span>
                            </div>   
                        </div>

                            </div>
                        </div>
              </tab-content>
              <tab-content title="Adresse" :before-change="carStoreStep">
                                <div class="form-group col-md-12">
                                            <label class="">Pays <span class="star_label">*</span></label>

                                            <multi-select class="country"
                                                no-ptions="Aucun revendeur disponible" open-direction="bottom"
                                                v-model="pays"  :options="_pays"
                                                @input="trackPays" 
                                                :show-labels="false" :searchable="true" :clear-on-select="false"
                                                :close-on-select="true"  placeholder="Choisissez le nom du pays" label="libelle" track-by="id">
                                                    <template slot="option" slot-scope="props">
                                                        <!-- <img width="20" class="option__image" :src="'/storage/flags/'+props.option.code2.toLowerCase()+'.png'" :alt="props.option.code1"> -->
                                                        <div class="option__desc"><span class="option__title">{{ props.option.libelle }}</span></div>
                                                    </template>
                                            </multi-select>
                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('pays_id')" v-text="form.errors.get('pays_id')"></span>
                                </div>
                                <div class="form-row">
                                        <div class="form-group col-md-6">
                                            <label class="">Nom de la rue <span class="star_label">*</span></label>
                                            <input placeholder="Entrez le nom de la rue"  class="form-control form-control-md form-custom-input-sm" name="rue" v-model="form.rue" type="text" />

                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('rue')" v-text="form.errors.get('rue')"></span>
                                        </div>
                                        <div class="form-group col-md-6">
                                            <label class="">Numéro</label>
                                            <input placeholder="Entrez le numéro de la rue"  class="form-control form-control-md form-custom-input-sm" name="nr" v-model="form.nr" type="text" />

                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('nr')" v-text="form.errors.get('nr')"></span>
                                        </div>
                                </div>

                                <div class="form-row">
                                        <div class="form-group col-md-6">
                                            <label class="">Boite Postale <span class="star_label">*</span></label>
                                            <input placeholder="Entrez la boite postale"  class="form-control form-control-md form-custom-input-sm" name="bp" v-model="form.bp" type="text" />

                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('bp')" v-text="form.errors.get('bp')"></span>
                                        </div>
                                        <div class="form-group col-md-6">
                                            <label class="">Quartier</label>
                                            <input placeholder="Entrez le nom du quartier"  class="form-control form-control-md form-custom-input-sm" name="quartier" v-model="form.quartier" type="text" />

                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('quartier')" v-text="form.errors.get('quartier')"></span>
                                        </div>
                                        <div class="form-group col-md-12">
                                            <label class="">Ville <span class="star_label">*</span></label>
                                            <input placeholder="Entrez le nom de la ville"  class="form-control form-control-md form-custom-input-sm" name="ville" v-model="form.ville" type="text" />

                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('ville')" v-text="form.errors.get('ville')"></span>
                                        </div>


                                </div>
              </tab-content>
              <tab-content title="Contact" :before-change="carStoreStep">
                        <div class="">
                            <div class="form-row">
                                        <div class="form-group col-md-6">
                                            <label class="">Téléphone 1 <span class="star_label">*</span></label>
                                            <input placeholder="Entrez le numéro de téléphone 1" class="form-control form-control-md form-custom-input-sm" name="phone1" v-model="form.phone1" type="text" />

                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('phone1')" v-text="form.errors.get('phone1')"></span>
                                        </div>
                                        <div class="form-group col-md-6">
                                            <label class="">Téléphone 2</label>
                                            <input placeholder="Entrez le numéro de téléphone 2" class="form-control form-control-md form-custom-input-sm" name="phone2" v-model="form.phone2" type="text" />

                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('phone2')" v-text="form.errors.get('phone2')"></span>
                                        </div>
                                       <div class="form-group col-md-12 col-sm-12">
                                            <label class="">E-mail <span class="star_label">*</span></label>
                                            <input placeholder="Entrez l'adresse e-mail"  class="form-control form-control-md form-custom-input-sm" name="email" v-model="form.email" type="text" />

                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('email')" v-text="form.errors.get('email')"></span>
                                        </div>
                                </div>
                                <div class="form-row">

                                        <div class="form-group col-md-6">
                                            <label class="">Siteweb</label>
                                            <input placeholder="Entrez le siteweb"  class="form-control form-control-md form-custom-input-sm" name="siteweb" v-model="form.siteweb" type="text" />

                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('siteweb')" v-text="form.errors.get('siteweb')"></span>
                                        </div>
                                        <div class="form-group col-md-6">
                                            <label class="">Facebook</label>
                                            <input placeholder="Entrez le facebook"  class="form-control form-control-md form-custom-input-sm" name="facebook" v-model="form.facebook" type="text" />

                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('facebook')" v-text="form.errors.get('facebook')"></span>
                                        </div>
                                </div>
                                <div class="form-row">

                                        <div class="form-group col-md-6">
                                            <label class="">twitter</label>
                                            <input placeholder="Entrez le twitter"  class="form-control form-control-md form-custom-input-sm" name="twitter" v-model="form.twitter" type="text" />

                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('twitter')" v-text="form.errors.get('twitter')"></span>
                                        </div>
                                        <div class="form-group col-md-6">
                                            <label class="">Linkedin</label>
                                            <input  placeholder="Entrez le linkedin" class="form-control form-control-md form-custom-input-sm" name="linkedin" v-model="form.linkedin" type="text" />

                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('linkedin')" v-text="form.errors.get('linkedin')"></span>
                                        </div>
                                </div>
                                
                        </div>

              </tab-content>
              <tab-content title="Récapitulatif" icon="fa  fa-check" :before-change="carStoreStep">
                        <div class="card no-border" style="border: none;box-shadow: none;">
                            <!-- /.card-header -->
                            <div class="card-body  p-0">
                                <div class="row">
                                    <div class="col-md-3">
                                        <div class="card card-primary card-outline card-outline-tabs" style=" margin-top: 10px;" v-if="hasImages">
                                            <div class="card-header p-0 border-bottom-0">
                                                <ul class="nav nav-tabs" id="custom-tabs-three-tab" role="tablist">
                                                    <li class="nav-item">
                                                        <a class="nav-link active" id="custom-tabs-three-home-tab" data-toggle="pill" href="#custom-tabs-three-home" role="tab" aria-controls="custom-tabs-three-home" aria-selected="true">Logo</a>
                                                    </li>
                                                </ul>
                                            </div>
                                            <div class="card-body p-0">
                                                <div class="tab-content" id="custom-tabs-three-tabContent">
                                                    <div class="tab-pane fade active show" id="custom-tabs-three-home" role="tabpanel" aria-labelledby="custom-tabs-three-home-tab">
                                                        <div class="row">
                                                                <div class="col-md-12 col-sm-12">
                                                                    <!-- Row profil-->
                                                                        <div class="card shadow-none   ">
                                                                                <div class="card-body p-0 profile-image-previewx">
                                                                                    <img v-if="form.logo!=''" :src="form.logo" alt="preview de votre image de profil">
                                                                                    <img v-else src="/img/industry-solid.png" alt="Aucune image de profil" width="250" class="img-fluid">
                                                                                </div>
                                                                        </div>
                                                                    <!-- /Row profil -->
                                                                </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                            <!-- /.card -->
                                        </div>
                                    </div>
                                    <div class="col-md-8 row">
                                        <div class="col-md-6 recap">
                                        <h6 class="preview-under-headline">Données Générales</h6>
                                        <table class="preview-table">
                                            <tr>
                                                <td>Nom commercial</td>
                                                <td>{{ form.nom_commercial}}</td>
                                            </tr>
                                            <tr>
                                                <td>Responsable</td>
                                                <td>{{ responsable ? responsable.fullName : ""}}</td>
                                            </tr>
                                            <tr>
                                                <td>form Juridique</td>
                                                <td>{{ form.forme_juridique}}</td>
                                            </tr>
                                            <tr>
                                                <td>Secteur d'activité</td>
                                                <td>{{ secteur_activite ? secteur_activite.libelle : ""}}</td>
                                            </tr>
                                            <tr>
                                                <td>Activité principale</td>
                                                <td>{{ form.activite_principale ?  form.activite_principale : "Non précisé"}}</td>
                                            </tr>
                                            <tr>
                                                <td>Autre activité</td>
                                                <td>{{ form.autre_activite ?  form.autre_activite : "Non précisé"}}</td>
                                            </tr>
                                            <tr>
                                                <td>Effectif</td>
                                                <td>{{ form.effectif}}</td>
                                            </tr>
                                        </table>
                                        <div class="separator separator-dashed my-2"></div>
                                    </div>
                                    <div class="col-md-6 recap">
                                        <h6 class="preview-under-headline">Adresse</h6>
                                        <table class="preview-table">
                                            <tr>
                                                <td>Nom de la rue</td>
                                                <td>{{ form.rue}} {{ form.nr}}</td>
                                            </tr>
                                            <tr>
                                                <td>N° de la rue</td>
                                                <td>{{ form.nr ? form.nr :""}}</td>
                                            </tr>
                                            <tr>
                                                <td>Boite postale</td>
                                                <td>{{ form.bp}}</td>
                                            </tr>
                                            <tr>
                                                <td>Quartier</td>
                                                <td>{{ form.quartier ? form.quartier : "Non précisé" }}</td>
                                            </tr>
                                            <tr>
                                                <td>Ville</td>
                                                <td>{{ form.ville}} , {{ pays ? pays.libelle : "Non précisé"}}</td>
                                            </tr> 
                                        </table>
                                    </div>
                                    <div class="col-md-6 recap">
                                        <h6 class="preview-under-headline">Contact</h6>
                                        <table class="preview-table">
                                            <tr>
                                                <td> <i class="fas fa-phone-square-alt mr-1"></i>Téléphone 1<span></span></td>
                                                <td>{{ (form.phone1 && form.phone1!="")  ? form.phone1 : "Non précisé"  }}</td>
                                            </tr>
                                            <tr>
                                                <td><i class="fas fa-phone-square-alt mr-1"></i>Téléphone 2<span></span></td>
                                                <td>{{ (form.phone2 && form.phone2!="")  ? form.phone2 : "Non précisé"  }}</td>
                                            </tr>
                                            <tr>
                                                <td><span><i class="fas fa-envelope-square mr-1"></i>E-mail</span></td>
                                                <td>{{ (form.email && form.email!="")  ? form.email : "Non précisé"  }}</td>
                                            </tr>
                                            <tr>
                                                <td><i class="fas fa-globe mr-1"></i>Siteweb<span></span></td>
                                                <td>{{ (form.siteweb && form.siteweb!="")  ? form.siteweb : "Non précisé"  }}</td>
                                            </tr>
                                            <tr>
                                                <td><i class="fab fa-facebook-square mr-1"></i>Facebook<span></span></td>
                                                <td>{{ (form.facebook && form.facebook!="")  ? form.facebook : "Non précisé"  }}</td>
                                            </tr>
                                            <tr>
                                                <td><i class="fab fa-twitter mr-1"></i>Twitter<span></span></td>
                                                <td>{{ (form.linkedin && form.linkedin!="")  ? form.linkedin : "Non précisé"  }}</td>
                                            </tr>
                                                                    <tr>
                                                <td><i class="fab fa-twitter mr-1"></i>Linkedin<span></span></td>
                                                <td>{{ (form.linkedin && form.linkedin!="")  ? form.linkedin : "Non précisé"  }}</td>
                                            </tr>
                                        </table>
                                    </div>
                                    </div>
                                </div>

                                <!-- Tabs -->

                                <!-- /.card-body -->
                            </div>
                            <!-- /.card-body -->
                        </div>
                    </tab-content>
                    <template slot="footer" slot-scope="props">
                        <div class="wizard-footer-left">
                        <wizard-button  v-if="props.activeTabIndex > 0 " @click.native="props.prevTab()" :style="props.fillButtonStyle" :disabled="form.errors.any() || isLoading || FileIsLoading"><i class="la la-arrow-left mr-2"></i> Retour </wizard-button>
                        </div>
                        <div class="wizard-footer-right">
                        <wizard-button v-if="!props.isLastStep" @click.native=" props.nextTab()" class="wizard-footer-right btn btn-block btn-primary btn-lg" :style="props.fillButtonStyle" :disabled="form.errors.any() || isLoading || FileIsLoading">
                            <span v-if="!isLoading">
                                Suivant <i class="la la-arrow-right ml-2"></i>
                            </span>
                            <span v-else class="pr-2">
                                <i class="m-loader m-loader--light m-loader--right ml-4 pr-1"></i>
                                <span>Chargement</span>
                            </span>
                            </wizard-button>

                        <wizard-button v-else @click.native="onSubmit" class="wizard-footer-right finish-button" :style="props.fillButtonStyle" :disabled="form.errors.any() || isLoading">

                            <span v-if="!isLoading">
                                Terminer <i class="la la-check ml-2"></i>
                            </span>
                            <span v-else class="pr-2">
                                <i class="m-loader m-loader--light m-loader--right ml-4 pr-1"></i>
                                <span>Chargement</span>
                            </span>
                            </wizard-button>
                        </div>
                    </template>
            </form-wizard>
        </form>
        </b-modal>
    </div>
</template>

<script>
  import _  from 'lodash'

import {FormWizard,WizardButton,WizardStep, TabContent} from 'vue-form-wizard'
import 'vue-form-wizard/dist/vue-form-wizard.min.css'
import { mapGetters } from 'vuex'

//component code

   import Form from "./../../classes/Form"
    export default {
        data()
        {
            return{

                isLoading:false,
                justTosayNo:false,
                imageProfileIsLoading:false,
                imageGalleryIsLoading:false,
                FileIsLoading:false,
                filesAdded:[],
                modeEdit:false,
                modeles : [],
                entity:'',
                FileLimit:4,
                fileType:"",
                isMounted:false,
                initLogo:false,
                oldImageUpdated:false,
                fileCounter:0,
                //VC-calendar
                mask:{

                    input: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                    data: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                },
                date_pmc:"",

                //multi-select
                marque:"",
                modele:"",
                motorisation:"",
                pays:"",
                permis:"",
                responsable:"",
                tvehicule:"",
                secteur_activite:"",
                forme_juridique:"",

                //Options selectionnées
                plaisirs : [],
                conforts : [],
                securites : [],

                searchingMember: false,

                opt:{
                    marques:[],
                    pays:[],
                    motorisations:[],
                    tvehicules:[],
                    optConfort:[],
                    optPlaisir:[],
                    optSecurite:[],
                    secteurs:[],
                    tpermis:[],
                    fjuridiques:["EI","SUARL/EURL","SARL","SAS","SASU","SA","SNC","SCS","GIE","Autre","SP","SCI"]
                },

                form : new Form(
                    {
                        //1
                        logo:"",
                        secteur_activite_id:"",
                        secteur_activite_principal: "",
                        effectif: "",
                        nom_commercial:"",
                        old_image:"",
                        forme_juridique: "",
                        autre_activite: "",
                        responsable_id:"",
                        
                        logoMustBeUpdated:false,

                        step:0,

                        //2 Adresse

                        nr: "",
                        rue: "",
                        ville: "",
                        bp: "",
                        pays_id: "",
                        quartier: "",

                        // 3 contact
                        phone1: "",
                        phone2: "",
                        email: "",
                        facebook: "",
                        twitter: "",
                        linkedin: "",


                        

                        //moteurs


                        //mesures physiques

                  }),

            }
        },
        computed:
         {
           ...mapGetters({memberAsParameter:'members/memberAsParameter',_formations:'params/_formations',_competences:"params/_competences",_pays:"params/_pays",_secteurs:'params/_secteurs',_promotions:"params/_promotions"}),
           membres: function()
            {
               return []
            },
           setTitle: function()
            {
               return this.title +=" : Areddd"
            },
            title ()
            {
            return  this.modeEdit ? " Modification d'une entreprise"  : " Ajout d'une entreprise"
            },
            ModalAction ()
            {
            return  this.modeEdit ? " Modifier"  : " Ajouter"
            },
            //Determine si le formulaire est à la derniere etape
            lastStep()
            {
              if(this.$refs.wizard) return this.$refs.wizard.isLastStep
              return   false
            },
            //Determine si le formulaire a des images
            hasImages()
            {
                   return true
            },
        },
        created()
        {
          // this.fetchOptions()
        },
        mounted()
         {

             //les options sont chargées
             this.isMounted = true;
            window.event.$on('new-enterprise-event',(e) => {
                     this.initForm()
                     this.showModal()
            })
            window.event.$on('update-enterprise-event',(e) => {
                this.modeEdit = true
                  this.entity = e
                  this.initUpdate()
                  this.showModal()
                  
            })
            
              this.$on('initOption', e => {
                this.initForm()
            })

        },
        methods:
        {
            beforeModalCloses()
            {
                this.$refs.cropper.remove();
               log("ok")
            },
            clearAll () {
            this.selectedCountries = []
            },
            zoomIn()
            {
            this.$refs.cropper.zoomIn()
            },
            zoomOut()
            {
            this.$refs.cropper.zoomOut()
            },
            rotateLeft()
            {
            this.$refs.cropper.rotate(-1)
            },
            rotateRight()
            {
            this.$refs.cropper.rotate()
            },
            onInitialImageLoaded()
            {
             // this.form.old_image = this.$refs.cropper.generateDataUrl(this.fileType)
             this.form.logoMustBeUpdated = false
             this.initLogo = true;
            },
            updateDraw()
            {
               //this.form.old_image = this.form.logo
               var temp=this.$refs.cropper.generateDataUrl(this.fileType)
               this.form.logo =temp;
            },
            updateImage()
            {
                 console.log("Draw was called")
               if(this.modeEdit)
               {
                       if(this.entity.hasLogo && this.initLogo==true )
                       {
                          this.form.logoMustBeUpdated = false
                       }
                       else
                       {
                          this.form.logoMustBeUpdated = true
                          console.log("L'image a été actualisée")
                       }
               }
               this.initLogo = false;
               var temp=this.$refs.cropper.generateDataUrl(this.fileType)
               this.form.logo =temp;
            },
            onFileTypeMismatch (file) {
                alert('Type de fichier invalide. Please choose a jpeg or png file.')
            },
            onFileChosen (file)
            {
                this.fileType = file.type
            },

            onRemoveLogo()
            {
                //Si l'entreprise a un logo par défaut
                if(this.entity.hasLogo == true)
                {
                    //alors le logo doit etre   actualisé
                    this.form.logoMustBeUpdated = true
                    console.log("Le logo a été actualisé")

                }
                else //Sinon
                {
                    //Le logo reste vide
                    this.form.logoMustBeUpdated = false
                }
                this.form.logo = ""
            },
            onFileSizeExceed (file) {
                alert('File size exceeds. Please choose a file smaller than 100kb.')
            },
 
            datepickerEvent(event)
            {
                this.form.phone1 = moment(event).format('YYYY-MM-DD')
                this.updateFormErrors("phone1")
                //this.moreParams.filter_date_fin_prev = moment(periode.end).format('YYYY-MM-DD')
                //Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            asyncFind(query)
            {
                this.searchingMember = true
                this.executeSync(query)
            },
            executeSync:_.debounce(function(query)
                {
                 // if(query=="") return
                  
                  this.searchingMember = true
                  this.$store.dispatch("members/memberAsParameter",query).then((response) =>
                {
                  this.searchingMember = false
                })
                },600)
               
                  //this.$store.dispatch("members/asParameters",query);
            ,
             fetchOptions()
             {
               axios.get("/api/dispatcher/options/entreprises").then((response) =>
                {
                      this.opt.marques = []
                      this.opt.motorisations = []
                      this.opt.tpermis = []
                      this.opt.tvehicules = []
                      this.opt.pays = response.data.pays
                      this.opt.secteurs = response.data.secteurs
                      this.$emit('option-fetch-event',response.data.secteurs)

                

                      //envoie un event pour signifier le chargement des options
                      this.$emit('initOption');
                      this.pageInit =true
                },
                (error) =>
                {
                  this.isLoading = false
                });
             },

             initForm()
            {

                    this.form.step="",

                    //General
                    this.form.logo="",
                    this.form.old_image="",
                    this.form.secteur_activite_principal= "",
                    this.form. images=[],
                    this.form.secteur_activite_id="",
                    this.form.responsable_id="",
                    this.form.modele_id="",
                    this.form.nom_commercial="",
                    this.form.forme_juridique= "",
                    this.form.autre_activite="",
                    this.form.effectif= "",
                    this.form.logoMustBeUpdated=false

                    //contact
                    this.form.phone1= "",
                    this.form.phone2= "",
                    this.form.linkedin= "",
                    this.form.twitter= "",
                    this.form.email= "",
                    this.form.facebook= "",

                

                    //Adresse
                    this.form.nr= "",
                    this.form.rue= "",
                    this.form.ville= "",
                    this.form.bp= "",
                    this.form.pays_id= "",
                    this.form.quartier= "",

                    this.pays = ""
                    this.responsable = ""
                    this.modele = ""
                    this.secteur_activite = ""
                    this.motorisation = ""
                    this.tvehicule = ""
                    this.entity=""

                    this.oldImageUpdated=false


            },
                        initUpdate()
            {

                    this.form.step="0"
                    this.form.id=this.entity.id
                    this.form.logoMustBeUpdated=false


                    //General
                    this.form.logo="",
                    this.form.secteur_activite_principal= this.entity.secteur_activite_principal
                    this.form.secteur_activite_id=this.entity.secteur_activite_id
                    this.form.modele_id=this.entity.modele_id
                    this.form.nom_commercial=this.entity.nom_commercial
                    this.form.forme_juridique= this.entity.forme_juridique
                    this.form.autre_activite=this.entity.autre_activite
                    this.form.effectif= this.entity.effectif
                     this.form.responsable_id=this.entity.responsable_id
                    //contact
                    this.form.phone1= this.entity.phone1
                    this.form.phone2= this.entity.phone2
                    this.form.siteweb= this.entity.siteweb
                    this.form.linkedin= this.entity.linkedin
                    this.form.twitter= this.entity.twitter
                    this.form.email= this.entity.email
                    this.form.facebook= this.entity.facebook

                

                    //Adresse
                    this.form.rue=this.entity.rue
                    this.form.nr= this.entity.nr
                    this.form.bp= this.entity.bp
                    this.form.ville= this.entity.ville
                    this.form.quartier = this.entity.quartier
                    this.form.pays_id = this.entity.pays_id



                    this.pays = this.entity.pays
                    this.responsable = this.entity.responsable ? this.entity.responsable : ""
                    this.secteur_activite= this.entity.secteur
                   

            },
            updateFormErrors(name)
            {
                if(this.form.errors.any()==true)
                {
                    //on retire l erreur
                    this.form.errors.clear(name)
                    //on verifie s il  n ya plus d erreurs
                    if(this.form.errors.any()==false)
                    {
                        this.$refs.wizard.tabs[this.form.step].validationError = null
                    }
                }

            },

          //ajout de la voiture par étape
          carStoreStep()
          {

                return new Promise((resolve, reject) => {
                    axios.post('/api/entreprises', this.form.data())
                        .then(response => {

                            resolve(true);
                        })
                        .catch(error => {
                            this.form.onFail(error.response.data);

                            reject(error.response.data);
                        });
                   });
          },
          onSubmit()
           {

                this.isLoading = true
                this.$store.dispatch(this.modeEdit ? "enterprises/updateEnterprise":"enterprises/addEnterprise",this.form).then((response) =>
                {

                    flash(!this.modeEdit ?"<span>Enregistré <strong>avec succès</strong></span>" : "<span>Modifié <strong>avec succès</strong></span>",'success')
                    this.isLoading = false
                    this.$refs['inputModal'].hide()
                },
                (error) => 
                     {
                      this.isLoading = false
                      flash("<span>Une erreur est survenu lors de l'opération</span>" ,'error')
                      console.log(error)
                      this.$refs['inputModal'].hide()
                    });
           },

            updateStep(prevIndex, nextIndex)
            {
                if(!this.form.errors.any())
                {

                  this.form.step = nextIndex
                  this.$forceUpdate()
                }
            },

            setLoading(value)
            {
               this.isLoading = value
            },
            addSecuriteOpt(option)
            {
              console.log(option)
            },
            //Charge l'image
            readURL(event)
            {
                this.imageProfileIsLoading = true
                  var input = event.srcElement;
                  if (input.files && input.files[0]) {
                var reader = new FileReader();
                  var vm = this
                reader.onload = function (e)
                {
                    $('.image-uploader-content img').attr('src', e.target.result);
                    vm.form.logo = e.target.result;
                    //console.log(e.target.result)
                    vm.imageProfileIsLoading = false
                };
                reader.readAsDataURL(input.files[0]);
            }},
            //Charge l'image
            onUploadDocument(name,event)
            {

                  var input = event.srcElement;
                  if (input.files && input.files[0])
                   {
                    var reader = new FileReader();
                    var vm = this
                    reader.onload = function (e)
                    {

                            vm.form[name].fichier = e.target.result;
                            vm.form[name].nom_fichier=input.files[0].name
                            vm.form[name].hasFile=true

                    };
                    reader.readAsDataURL(input.files[0]);
                   }
            },
             //Retire l'image des
            removeImage(index)
            {
               this.form.images.splice(index,1)

            },
            //Charge les images de la galerie
            readURLGalerie(event)
            {
                  var input = event.srcElement;
                  this.imageGalleryIsLoading = true
                  if (input.files && input.files[0])
                  {

                      var index = 0
                      var vm = this
                      this.fileCounter = input.files.length
                      this.imageGalleryIsLoading = true
                      for(index;index<input.files.length;index++)
                      {
                        var reader = new FileReader();
                        reader.onload = function (e)
                        {
                            //$('.image-uploader-content img').attr('src', e.target.result);
                            //vm.form.logo = e.target.result;
                            vm.form.images.push(e.target.result)
                            vm.fileCounter--

                        };
                        reader.readAsDataURL(input.files[index]);
                      }
                   }
            },
             registerFile(event)
            {
              this.form.images.push(event.dataURL)
              this.FileIsLoading = false
            },
            removedfileFromDropzone(file, error, xhr)
            {
                var oldSize = this.form.images.length
                this.form.images= this.form.images.filter(e => { return e !==file.dataURL })
                if(this.form.images.length != oldSize)
                {
                    this.FileLimit++
                }

            },
            fileAdded(event)
            {

                 
              var reader = new FileReader();
              var vm = this
              reader.onload = function (e)
              {
                    if(vm.FileLimit > 0)
                    {
                        vm.form.images.push(e.target.result)
                        vm.FileLimit--;
                    }
                    else
                    {
                        vm.$refs.dropzone.removeFile(event)
                    }
                   
            
              };
            
             reader.readAsDataURL(event);
             
       
              
            },
            maxFilesReached(file)
            {
              //console.log(file)
              //this.$refs.dropzone.removeFile(file)
            },
            onComplete()
            {

            },
            showModal()
             {

                this.$refs['inputModal'].show()
                this.$forceUpdate()

             },
             showModalOnEdit(entity)
             {
                  this.modeEdit = true
                  this.form.nom_commercial = entity.nom_commercial
                  this.form.id=entity.id
                  this.$refs['inputModal'].show()
             },
              reset()
             {
                  if(this.modeEdit)
                  {
                      log(this.$refs.cropper)
                  }
                  this.initForm()
                  this.form.errors.clearAll();
                   this.entity=""
             },

             // Events
             trackSecteurActivite(e)
             {
                             log(this.$refs.cropper)

                 if(e!=null)
                 {
                   this.form.secteur_activite_id = e.id

                 }
                 else
                 {

                 }
                 this.updateFormErrors("secteur_activite_id");


             },
              trackModele(e)
             {
                 if(e!=null)
                 {
                   this.form.modele_id = e.id
                 }
                 else
                 {
                   this.form.modele_id =""
                 }
             },
             trackResponsable(e)
             {
                 if(e!=null)
                 {
                   this.form.responsable_id = e.id
                 }
                 else
                 {
                   this.form.responsable_id =""
                 }
             },
            trackTM(e)
             {
                 if(e!=null)
                 {
                   this.form.modele_id = e.id
                 }
                 else
                 {
                   this.form.modele_id =""
                 }
             },
              trackPays(e)
             {
                 if(e!=null)
                 {
                   this.form.pays_id = e.id
                 }
                 else
                 {
                    this.form.pays_id = ""
                 }
                 this.updateFormErrors("pays_id");
             },
             trackEffectif(e)
             {
                 if(e!=null)
                 {
                   this.form.pays_id = e.id
                 }
                 else
                 {
                    this.form.pays_id = ""
                 }
                 this.updateFormErrors("effectif");
             }
        },
        components:
         {
          FormWizard,
          TabContent,WizardButton,WizardStep,
         },
         watch:
         {
             "fileCounter":function(val)
             {
                 if(this.fileCounter==0 && this.imageGalleryIsLoading == true)
                 {
                     this.imageGalleryIsLoading = false
                 }
             },
            "OptionsIds":function(val)
             {
                 this.form.options = val
             },
             "form.secteur_activite_id" : function(value)
             {
                 if(value!="")
                 {
                  this.updateFormErrors("secteur_activite_id");
                 }

             },

             "form.modele_id" : function(value)
             {
                 if(value!="")
                 this.updateFormErrors("modele_id");
             },
            "form.email" : function(value)
             {
                 if(value!="")
                 this.updateFormErrors("email");
             }
             ,
             "form.logo" : function(value,old)
             {
                if(this.modeEdit)
                 {
                   if(this.entity.hasLogo && this.oldImageUpdated == false)
                   {
                       this.form.old_image = value
                       this.oldImageUpdated=true
                   }
                 }
             },
            "form.facebook" : function(value)
             {
                 if(value!="")
                 this.updateFormErrors("facebook");
             }
             ,
            "form.forme_juridique" : function(value)
             {
                 if(value!="")
                 this.updateFormErrors("forme_juridique");
             }
         }

    }
</script>
<style lang="scss">
.wizard-header,.wizard-progress-with-circle {
    display:none !important;
}
.dataTables_info select {
    width: auto;
    display: inline-block;

        height: calc(1.5em + 1rem + 2px);
    padding-top: 0.5rem;
    padding-bottom: 0.5rem;
    padding-left: 1rem;
    font-size: 0.875rem;
    padding: 0.65rem 2rem 0.65rem 1rem;
    font-weight: 400;
    line-height: 1.5;
    color: #495057;
    vertical-align: middle;
    background: #fff url("data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='4' height='5' viewBox='0 0 4 5'%3e%3cpath fill='%23343a40' d='M2 0L0 2h4zm0 5L0 3h4z'/%3e%3c/svg%3e") no-repeat right 1rem center/8px 10px;
    border: 1px solid #e2e5ec;
    border-radius: 0.25rem;
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;

}
.vue-dropzone
{
    width: 100%;
    margin-top: 34px;
    min-height: 270px;
    position:relative;
    display: flex;
    -webkit-box-pack: center !important;
    justify-content: center !important;
    
}
.dz-message{
    width: 50%;
    margin: auto !important;
    position: absolute;
    top: 50%;
    left: 50%;
    -webkit-transform: translate(-50%,-50%);
    -ms-transform: translate(-50%,-50%);
    transform: translate(-50%,-50%);
}

.profile-image-preview {
    width: 300px !important;
}
.profile-image-preview img {
    width: inherit !important;
    height: inherit !important;
    -o-object-fit: contain !important;
    object-fit: contain !important;
}
.country .multiselect__option
{
    display: flex;
}
.country .multiselect__option img
{
    margin-right: 10px;
    color: rgba(0, 0, 0, 0) !important;

}
.recap h6
{
    font-weight: 600!important;
    margin-bottom: .75rem!important;
    font-size: 0.975rem;
}
.recap table tr td:first-child
{
    font-weight: 900;
}
.recap table tr td:last-child
{
   padding-left:10px;
   color:#80808f!important;
   line-height: 1.5;
     white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
    position: relative;
  display: inline-block;
      max-width: 160px;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
}
.responsable-input .multiselect__content .input li > span > span.remove-options
{
   display: none !important;
}
.profile-image-previewx {
    width: 250px !important;
    height: 250px !important;
}
.profile-image-previewx  img{
width: inherit;

}
#my-modal___BV_modal_body_
{
  padding-top: 10px !important;
  padding-bottom: 0 !important;
}
.vue-form-wizard .wizard-tab-content {
    min-height: 100px;
    padding: 10px 20px 10px;
}
</style>
